Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions
Lucene::SpanFilter Class Referenceabstract

Abstract base class providing a mechanism to restrict searches to a subset of an index and also maintains and returns position information. More...

`#include <SpanFilter.h>`

Inheritance diagram for Lucene::SpanFilter:

## Public Member Functions

virtual | ~SpanFilter ()
virtual String | getClassName ()
boost::shared_ptr< SpanFilter > | shared_from_this ()
virtual SpanFilterResultPtr | bitSpans (const IndexReaderPtr &reader)=0
| Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match. More...
Public Member Functions inherited from Lucene::Filter
virtual | ~Filter ()
boost::shared_ptr< Filter > | shared_from_this ()
virtual DocIdSetPtr | getDocIdSet (const IndexReaderPtr &reader)=0
| Creates a DocIdSet enumerating the documents that should be permitted in search results. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Filter
static String | _getClassName ()

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Abstract base class providing a mechanism to restrict searches to a subset of an index and also maintains and returns position information.

This is useful if you want to compare the positions from a SpanQuery with the positions of items in a filter. For instance, if you had a SpanFilter that marked all the occurrences of the word "foo" in documents, and then you entered a new SpanQuery containing bar, you could not only filter by the word foo, but you could then compare position information for post processing.

## Constructor & Destructor Documentation

## ◆ ~SpanFilter()

virtual Lucene::SpanFilter::~SpanFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::SpanFilter::_getClassName | ( |  | ) |

inline static

## ◆ bitSpans()

virtual SpanFilterResultPtr Lucene::SpanFilter::bitSpans | ( | const IndexReaderPtr & | reader | ) |

pure virtual

Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match.

Parameters

  reader | The IndexReader to load position and DocIdSet information from

Returns
  A SpanFilterResult

Implemented in Lucene::CachingSpanFilter, and Lucene::SpanQueryFilter.

## ◆ getClassName()

virtual String Lucene::SpanFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::Filter.

Reimplemented in Lucene::SpanQueryFilter, and Lucene::CachingSpanFilter.

## ◆ shared_from_this()

boost::shared_ptr< SpanFilter > Lucene::SpanFilter::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- SpanFilter.h

clucene.sourceforge.net